//---------------------------------------------------------------------------
#ifndef CalMonthH
#define CalMonthH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <DsgnIntf.hpp>
#include <vcl\Grids.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\graphics.hpp>
#include <vcl\buttons.hpp>
//---------------------------------------------------------------------------

class PACKAGE TCalMonth : public TPanel
{
public:
    enum eMonth {January,
                 February,
                 March,
                 April,
                 May,
                 June,
                 July,
                 August,
                 September,
                 October,
                 November,
                 December};

    enum eDayAlign {_LeftTop,    _Top,    _RightTop,
                    _Left,       _Center, _Right,
                    _LeftBottom, _Bottom, _RightBottom };

    enum eDayBorderStyle {sunken, raised};
    typedef void __fastcall (__closure *TMonthChangeEvent)(System::TObject*Sender, int param1);
    typedef void __fastcall (__closure *TDrawEvent)(TObject *Sender, int DOW, int Date);

private:
    TDrawGrid* FCalGrid;
    eMonth FMonth;
    unsigned short int FYear;
    unsigned short int FDay;
    TLabel* MonthLabel;
    TLabel* YearLabel;
    TStringList* FDayStrings;
    TStringList* FMonthStrings;
    TBitBtn* FBackBtn;
    TBitBtn* FForeBtn;
    TFont* FMonthFont;
    TFont* FDayFont;
    TFont* FDOWFont;
    eDayAlign FDayAlign;
    TFont* FYearFont;
    Graphics::TBitmap* FBackGlyph;
    Graphics::TBitmap* FForeGlyph;
    Graphics::TBitmap* bmapL;
    Graphics::TBitmap* bmapR;
    TColor FDayBGColor;
    TColor FNonDayBGColor;
    eDayBorderStyle FDOWHeaderBorderStyle;
    eDayBorderStyle FDayBorderStyle;
    eDayBorderStyle FNonDayBorderStyle;
    TMonthChangeEvent FOnMonthChange;
    TNotifyEvent FOnDayClicked;
    TNotifyEvent FOnDayDblClicked;
    TDrawEvent FOnBeforeDayDraw;
    TDrawEvent FOnAfterDayDraw;
    bool FMonthNameTransparent;
    bool FYearTransparent;
    unsigned long int FTabDays;
    bool FRoundedCorners;
    TColor FBackBtnBG;
    TColor FDaySelectedColor;
    TColor FDOWHeaderBGColor;
    TColor FWeekendBGColor;
    int FBannerHeight;
    TColor FTabColor;

    Graphics::TBitmap* FMark1Image;
    unsigned long FMark1Days;
    eDayAlign FMark1Align;

    Graphics::TBitmap* FMark2Image;
    unsigned long FMark2Days;
    eDayAlign FMark2Align;

    Graphics::TBitmap* FMark3Image;
    unsigned long FMark3Days;
    eDayAlign FMark3Align;

    Graphics::TBitmap* FMark4Image;
    unsigned long FMark4Days;
    eDayAlign FMark4Align;

    void __fastcall SetMonthNameTransparent(bool value);
    void __fastcall SetYearTransparent(bool value);
    void __fastcall SetTabDays(unsigned long int value);
    void __fastcall SetRoundedCorners(bool value);
    void __fastcall SetDaySelectedColor(TColor value);
    void __fastcall SetMonth(eMonth value);
    void __fastcall SetYear(unsigned short int value);
    void __fastcall SetDay(unsigned short int value);
    void __fastcall SetDayFont(TFont* value);
    void __fastcall SetMonthFont(TFont* value);
    void __fastcall SetDOWFont(TFont* value);
    void __fastcall SetDayStrings(TStringList* value);
    void __fastcall SetMonthStrings(TStringList* value);
    void __fastcall SetBackBtn(TBitBtn* value);
    void __fastcall SetDayAlign(eDayAlign value);
    void __fastcall SetYearFont(TFont* value);
    void __fastcall SetBackGlyph(Graphics::TBitmap* value);
    void __fastcall SetForeGlyph(Graphics::TBitmap* value);
    void __fastcall SetDayBGColor(TColor value);
    void __fastcall SetNonDayBGColor(TColor value);
    void __fastcall SetDOWHeaderBorderStyle(eDayBorderStyle value);
    void __fastcall SetDayBorderStyle(eDayBorderStyle value);
    void __fastcall SetNonDayBorderStyle(eDayBorderStyle value);
    void __fastcall SetDOWHeaderBGColor(TColor value);
    void __fastcall SetWeekendBGColor(TColor value);
    void __fastcall SetBannerHeight(int value);
    void __fastcall SetTabColor(TColor value);

    void __fastcall SetMark1Image(Graphics::TBitmap* value);
    void __fastcall SetMark1Days(unsigned long int value);
    void __fastcall SetMark1Align(eDayAlign value);

    void __fastcall SetMark2Image(Graphics::TBitmap* value);
    void __fastcall SetMark2Days(unsigned long int value);
    void __fastcall SetMark2Align(eDayAlign value);

    void __fastcall SetMark3Image(Graphics::TBitmap* value);
    void __fastcall SetMark3Days(unsigned long int value);
    void __fastcall SetMark3Align(eDayAlign value);

    void __fastcall SetMark4Image(Graphics::TBitmap* value);
    void __fastcall SetMark4Days(unsigned long int value);
    void __fastcall SetMark4Align(eDayAlign value);

protected:
    void __fastcall GridDrawCell(TObject*, int, int, const TRect&, TGridDrawState);
    void __fastcall GridSelectCell(TObject*, int, int, bool&);
    void __fastcall Loaded(void);
    void __fastcall BackBtnClicked(TObject*);
    void __fastcall ForeBtnClicked(TObject*);
    void __fastcall Resize(void);
    void __fastcall CalGridClicked(TObject* Sender);
    void __fastcall CalGridDblClicked(TObject* Sender);

public:
  __fastcall TCalMonth(TComponent* Owner);
  __fastcall ~TCalMonth();
    void AddTabDate(unsigned short int tabDate);
    void RemoveTabDate(unsigned short int tabDate);
  __property TBitBtn* BackBtn  = { read = FBackBtn};
  __property TBitBtn* ForeBtn  = { read = FForeBtn };

__published:
  __property TNotifyEvent OnDayClicked = {read = FOnDayClicked, write = FOnDayClicked};
  __property TNotifyEvent OnDayDblClicked = {read = FOnDayDblClicked, write = FOnDayDblClicked};
  __property eMonth Month        = { read = FMonth, write = SetMonth, stored = true };
  __property unsigned short int Year    = { read = FYear, write = SetYear, stored = true };
  __property unsigned short int Day     = { read = FDay, write = SetDay, stored = true };
  __property TStringList* DayStrings    = { read = FDayStrings, write = SetDayStrings, stored = true};
  __property TStringList* MonthStrings  = { read = FMonthStrings, write = SetMonthStrings, stored = true};
  __property TFont* MonthFont    = { read = FMonthFont, write = SetMonthFont, stored = true };
  __property TFont* DayFont      = { read = FDayFont, write = SetDayFont, stored = true };
  __property TFont* DOWFont  = { read = FDOWFont, write = SetDOWFont, stored = true };
  __property eDayAlign DayAlign  = { read = FDayAlign, write = SetDayAlign, default = _Center, stored = true };
  __property TFont* YearFont  = { read = FYearFont, write = SetYearFont, stored = true };
  __property Graphics::TBitmap* BackGlyph  = { read = FBackGlyph, write = SetBackGlyph, stored = true };
  __property Graphics::TBitmap* ForeGlyph  = { read = FForeGlyph, write = SetForeGlyph, stored = true };
  __property TColor DayBGColor  = { read = FDayBGColor, write = SetDayBGColor };
  __property TColor NonDayBGColor  = { read = FNonDayBGColor, write = SetNonDayBGColor };
  __property eDayBorderStyle DOWHeaderBorderStyle  = { read = FDOWHeaderBorderStyle, write = SetDOWHeaderBorderStyle };
  __property eDayBorderStyle DayBorderStyle  = { read = FDayBorderStyle, write = SetDayBorderStyle };
  __property eDayBorderStyle NonDayBorderStyle  = { read = FNonDayBorderStyle, write = SetNonDayBorderStyle };
  __property TMonthChangeEvent OnMonthChange  = { read = FOnMonthChange, write = FOnMonthChange };
  __property bool MonthNameTransparent  = { read = FMonthNameTransparent, write = SetMonthNameTransparent,default = true};
  __property bool YearTransparent  = { read = FYearTransparent, write = SetYearTransparent, default = true};
  __property unsigned long int TabDays  = { read = FTabDays, write = SetTabDays };
  __property bool RoundedCorners  = { write = SetRoundedCorners, read = FRoundedCorners, default = false };
  __property TColor DaySelectedColor  = { write = SetDaySelectedColor, read = FDaySelectedColor };
  __property TColor DOWHeaderBGColor  = { read = FDOWHeaderBGColor, write = SetDOWHeaderBGColor };
  __property TColor WeekendBGColor  = { read = FWeekendBGColor, write = SetWeekendBGColor };
  __property int BannerHeight  = { read = FBannerHeight, write = SetBannerHeight };
  __property TColor TabColor  = { read = FTabColor, write = SetTabColor };

  __property Graphics::TBitmap* Mark1Image  = { read = FMark1Image, write = SetMark1Image };
  __property unsigned long int Mark1Days  = { read = FMark1Days, write = SetMark1Days };
  __property eDayAlign Mark1Align  = { read = FMark1Align, write = SetMark1Align, default = _LeftBottom };

  __property Graphics::TBitmap* Mark2Image  = { read = FMark2Image, write = SetMark2Image };
  __property unsigned long int Mark2Days  = { read = FMark2Days, write = SetMark2Days };
  __property eDayAlign Mark2Align  = { read = FMark2Align, write = SetMark2Align, default = _RightBottom };

  __property Graphics::TBitmap* Mark3Image  = { read = FMark3Image, write = SetMark3Image };
  __property unsigned long int Mark3Days  = { read = FMark3Days, write = SetMark3Days };
  __property eDayAlign Mark3Align  = { read = FMark3Align, write = SetMark3Align, default = _Top };

  __property Graphics::TBitmap* Mark4Image  = { read = FMark4Image, write = SetMark4Image };
  __property unsigned long int Mark4Days  = { read = FMark4Days, write = SetMark4Days };
  __property eDayAlign Mark4Align  = { read = FMark4Align, write = SetMark4Align, default = _Center };

  __property TDrawEvent OnBeforeDayDraw = {read = FOnBeforeDayDraw, write = FOnBeforeDayDraw};
  __property TDrawEvent OnAfterDayDraw  = {read = FOnAfterDayDraw,  write = FOnAfterDayDraw};
};

//---------------------------------------------------------------------------
#endif

